! *************************************************************
!   gNJ[uCR}bvi[pf[^\
! *************************************************************
module hvtransfc

!   ------------------------------------------------------------
!   TYPE STQCURVE
!   torque curves ( for maximam, frictional )
!   ------------------------------------------------------------
    type stqcurve
        integer ndata                                           ! number of point
        real(8), pointer :: rev(:)                              ! engine speed, rpm
        real(8), pointer :: tq(:)                               ! torque, Nm
    end type stqcurve

!   ------------------------------------------------------------
!   TYPE SFCMAP
!   fuel map (measured data for input)
!   ------------------------------------------------------------
    type sfcmap
        real(8) fcidle                                          ! idling fuel consumption, L/h
        integer ndata                                           ! number of data point
        real(8), pointer :: rev(:)                              ! engine speed, rpm
        real(8), pointer :: tq(:)                               ! torque, Nm
        real(8), pointer :: fc(:)                               ! fuel consumption, l/h
    end type sfcmap

!   ------------------------------------------------------------
!   TYPE SGRIDMAP
!   grid interpolated fuel map (calculated in the simulation)
!   ------------------------------------------------------------
    type sgridmap
        real(8) fcidle                                          ! idling fuel consumption, l/h
        integer nx                                              ! number of point in X-axis(eng speed)
        integer ny                                              ! number of point in Y-axis(torque)
        real(8), pointer :: rev(:)                              ! engine speed, rpm
        real(8), pointer :: tq(:)                               ! torque, Nm
        real(8), pointer :: fc(:,:)                             ! fuel consumption, l/h
    end type sgridmap

end module hvtransfc



