! **************************************************************
! MAIN PROGRAM Calculation of fuel consumption for HEV
! 2006/5/19
! 2006/5/23 calcfchev AChOXgbvl
! 2007/1/26 calcfchev AChOԂ̔fύX
!           F5CF4AChOƂ݂Ȃ
!           compiler = Intel Visual Fortran 9.0
! **************************************************************
PROGRAM hevfc0126
    use hvtransfc
    use msubfc
    use iohev
    implicit none

    type ( stqcurve ) :: ftqc                                   ! CgN
    type ( sfcmap ) :: fcm                                      ! ͔R}bv
    type ( sgridmap ) :: gfcm                                   ! Obhԃ}bv
    character ( len=1024 ) :: inputf='', mapf="", ftqf=""      ! filename
    character ( len=1024 ) :: inf = "", outf = ""
    integer, pointer :: sp(:)
    real(8), pointer :: t(:), v(:), ne(:), tq(:), fcx(:)
    real(8) nidle, nrate                                       ! AChOCi] rpm
    integer ndata                                               ! sԃf[^̃|Cg
    real(8) avgv, avgfc, dist, dt, fuelc                        ! ϑxCRo

!   -----------------------------------------------------------
!    Get Specification filename
!   -----------------------------------------------------------
    call GETARG(1, inf)
    call GETARG(2, outf)
    if ( inf == "" ) then
        do while ( inf == '' )
            write( *, '(A,$)' ) 'TYPE FILENAME FOR DATASET : '
            read ( *, * ) inf
        end do
    end if

    if ( outf == "" ) then
        do while ( outf == '' )
            write( *, '(A,$)' ) 'TYPE FILENAME FOR OUTPUT : '
            read ( *, * ) outf
        end do
    end if

!   -----------------------------------------------------------
!    Read input data
!   -----------------------------------------------------------
    call readdataset2 ( 10, inf, inputf, mapf, ftqf, dt, nidle, nrate )    ! ̓f[^t@C̎擾
    call readrunningdata ( 11, trim(inputf), ndata, t,v,ne,tq, sp ) ! sf[^ǂݍ݁Cf[^JEg
    allocate( fcx( ndata ) )                                        ! Ri[pm

    call readtqfc( 15, trim(ftqf), ftqc )                           ! CgN
    call readmapfc( 17, trim(mapf), fcm )                           ! R}bvǂ݂

!   -----------------------------------------------------------
!    Calculate fuel consumption
!   -----------------------------------------------------------
    call fcgrid( gfcm, fcm, ftqc )                                  ! Obhԃ}bv
    call calcfchev2 ( v, ne, tq, sp, fcx, ndata, ftqc, gfcm, nidle, nrate )           ! RʌvZ
    call calcave( v, fcx, ndata, dt, dist, fuelc, avgv, avgfc )     ! RlvZ

!   -----------------------------------------------------------
!    Output results
!   -----------------------------------------------------------
    print*, "----------------------------------------------------------"
    print '( A,F0.5,A,F0.4 )', "DIST(km) : ",dist, ", FUEL(L) : ",fuelc
    print '( A,F8.4,A,F0.1 )', "FC(km/l) : ",avgfc, ", Average Speed(km/h) : ",avgv
    print *
    print '( " OUTPUT FILE : ", A )', trim( outf )

!   -----------------------------------------------------------
!    R,ϑx,s̎Zo
    call outaveragefc ( 21, outf, inputf, mapf, ftqf, dist, fuelc, avgv, avgfc )
!   -----------------------------------------------------------
!    nf[^̏o
    call outtimeseriesfc (21,outf,ndata,t,v,ne,tq,sp,fcx)

!   -----------------------------------------------------------
!    
    deallocate ( ftqc%rev, ftqc%tq )
    deallocate ( fcm%rev, fcm%tq, fcm%fc, gfcm%rev, gfcm%tq, gfcm%fc )
    deallocate ( sp, t,v,ne,tq,fcx )

    print*, ' complete.'

end program hevfc0126
